package jdeveloper;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.JLabel;
import java.io.*;

import EasyXLS.*;
import EasyXLS.Charts.*;
import EasyXLS.Constants.*;



public class MainFrame extends JFrame {
  private JPanel contentPane;
  String[] columnNames = {"Project","Resource","Role", "Task","Estimated", "Regular", "OT Hours", "NB Hours","Approval Status"};
  Object[][] data = {
    {"EasyXLS", "Jim Bean", "Programmer", "Build Charts", new Integer(800), new Integer(240), new Integer(40), new Integer(0), "To be Approved"},
    {"EasyXLS", "Jack White", "Programmer", "Build Worksheets", new Integer(1000), new Integer(160), new Integer(0), new Integer(0), "To be Approved"},
    {"EasyXLS", "Christina Brown", "Programmer", "Build Hyperlinks", new Integer(750), new Integer(256), new Integer(2), new Integer(0), "To be Approved"},
    {"EasyXLS", "Walt Whitman", "Programmer", "Create Tutorials", new Integer(600), new Integer(114), new Integer(10), new Integer(0), "To be Approved"},
    {"EasyXLS", "Adam Wilson", "Tester", "Test Charts", new Integer(120), new Integer(8), new Integer(0), new Integer(0), "To be Approved"},
    {"EasyXLS", "Will Crane", "Tester", "Test Hyperlinks", new Integer(100), new Integer(10), new Integer(2), new Integer(0), "To be Approved"},
    {"EasyXLS", "George Brown", "Artist", "Design", new Integer(300), new Integer(150), new Integer(2), new Integer(0), "To be Approved"},
    {"MS Excel", "Christian Wurm", "Programmer", "Database Design", new Integer(120), new Integer(35), new Integer(3), new Integer(0), "To be Approved"},
    {"MS Excel", "Adrian Fisher", "Tester", "Speed", new Integer(240), new Integer(48), new Integer(0), new Integer(8), "To be Approved"},
    {"Totals", "", "", "", new Integer(0), new Integer(0), new Integer(0), new Integer(0), ""}
  };

  JTable dtTable = new JTable(data, columnNames);
  private JButton btnExportToExcel = new JButton();
  private JLabel hlkEasyXLS = new JLabel();
  private JLabel jLabel1 = new JLabel();
  private JLabel imgEasyXLSlogo = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JLabel jLabel3 = new JLabel();
  private JLabel jLabel4 = new JLabel();
  private JLabel jLabel5 = new JLabel();
  private JCheckBox chkTask = new JCheckBox();
  private JCheckBox chkEstimated = new JCheckBox();
  private JCheckBox chkRegular = new JCheckBox();
  private JCheckBox chkOTHours = new JCheckBox();
  private JCheckBox chkNBHours = new JCheckBox();
  

  public MainFrame() {
    try {
      jbInit();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setEnabled(true);
    contentPane.setPreferredSize(new Dimension(10, 100));
    contentPane.setLayout(null);
    this.setResizable(false);
    this.setSize(new Dimension(859, 601));
    this.setTitle("EasyXLS Demo");

    // Set the properties of the JTable component.
    dtTable.setEnabled(false);
    dtTable.setPreferredSize(new Dimension(785, 175));
    dtTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
    dtTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    dtTable.setSelectionBackground(Color.WHITE);
    dtTable.setSelectionForeground(Color.BLACK);
    dtTable.getTableHeader().setReorderingAllowed(false);
    dtTable.getTableHeader().setResizingAllowed(false);

    //Create the scroll pane and add the table to it.
    JScrollPane scrollPane = new JScrollPane(dtTable);

    //Add the scroll pane to this panel.
    scrollPane.setPreferredSize(new Dimension(790, 441));
    scrollPane.setBounds(new Rectangle(26, 149, 789, 199));

    btnExportToExcel.setBounds(new Rectangle(30, 507, 114, 23));
    btnExportToExcel.setText("Export xls file");
    btnExportToExcel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnExportToExcel_actionPerformed(e);
      }
    });
    hlkEasyXLS.setForeground(Color.blue);
    hlkEasyXLS.setToolTipText("http://www.easy-xls.com");
    hlkEasyXLS.setText("<HTML><u>www.easy-xls.com</u></HTML>");
    hlkEasyXLS.setBounds(new Rectangle(29, 96, 116, 20));
    hlkEasyXLS.addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseMoved(MouseEvent e) {
        hlkEasyXLS_mouseMoved(e);
      }
    });

    hlkEasyXLS.addMouseListener(new MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        hlkEasyXLS_mousePressed(e);
      }
    });

    jLabel1.setMaximumSize(new Dimension(300, 200));
    jLabel1.setMinimumSize(new Dimension(300, 200));
    jLabel1.setPreferredSize(new Dimension(300, 200));
    jLabel1.setVerticalAlignment(SwingConstants.TOP);
    jLabel1.setVerticalTextPosition(SwingConstants.TOP);
    jLabel1.setBounds(new Rectangle(220, 26, 604, 67));
    imgEasyXLSlogo.setBounds(new Rectangle(29, 10, 170, 60));
    jLabel2.setFont(new java.awt.Font("Dialog", 2, 12));
    jLabel2.setForeground(Color.gray);
    jLabel2.setText("* sample image");
    jLabel2.setBounds(new Rectangle(31, 69, 92, 20));
    jLabel3.setBounds(new Rectangle(27, 113, 118, 20));
    jLabel3.setText("* sample hyperlink");
    jLabel3.setForeground(Color.gray);
    jLabel3.setFont(new java.awt.Font("Dialog", 2, 12));
    jLabel4.setFont(new java.awt.Font("Dialog", 2, 12));
    jLabel4.setForeground(Color.gray);
    jLabel4.setText("* sample data set source; totals are computed using formulas");
    jLabel4.setBounds(new Rectangle(27, 349, 398, 20));
    jLabel5.setText(" Generate chart with the following columns:");
    jLabel5.setBounds(new Rectangle(28, 382, 316, 18));
    chkTask.setEnabled(false);
    chkTask.setSelected(true);
    chkTask.setText("Task");
    chkTask.setBounds(new Rectangle(72, 403, 86, 16));
    chkEstimated.setBounds(new Rectangle(72, 423, 86, 16));
    chkEstimated.setSelected(true);
    chkEstimated.setText("Estimated");
    chkRegular.setSelected(true);
    chkRegular.setText("Regular");
    chkRegular.setBounds(new Rectangle(72, 443, 86, 16));
    chkOTHours.setSelected(true);
    chkOTHours.setText("OT Hours");
    chkOTHours.setBounds(new Rectangle(72, 463, 86, 16));
    chkNBHours.setSelected(true);
    chkNBHours.setText("NB Hours");
    chkNBHours.setBounds(new Rectangle(72, 483, 86, 16));
    contentPane.add(scrollPane, null);
    imgEasyXLSlogo.setIcon(new ImageIcon("EasyXLSlogo.jpg"));
    contentPane.add(imgEasyXLSlogo, null);
    contentPane.add(jLabel2, null);
    contentPane.add(hlkEasyXLS, null);
    contentPane.add(jLabel4, null);
    contentPane.add(jLabel3, null);
    contentPane.add(jLabel5, null);
    contentPane.add(chkTask, null);
    contentPane.add(chkEstimated, null);
    contentPane.add(chkRegular, null);
    contentPane.add(chkOTHours, null);
    contentPane.add(chkNBHours, null);
    contentPane.add(btnExportToExcel, null);
    contentPane.add(jLabel1, null);
    imgEasyXLSlogo.setIconTextGap(0);

    // Computing the totals
    int nTotal = 0;
    for (int nColumnIndex = 4; nColumnIndex < 8; nColumnIndex++)
    {
      nTotal = 0;
      for (int nRowIndex = 0; nRowIndex < dtTable.getRowCount()-1; nRowIndex++)
      {
        nTotal += Integer.parseInt(dtTable.getValueAt(nRowIndex, nColumnIndex).toString()) ;
      }
      dtTable.setValueAt(nTotal + "", dtTable.getRowCount() - 1, nColumnIndex);
    }
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void hlkEasyXLS_mouseMoved(MouseEvent e) {
    hlkEasyXLS.setCursor(new Cursor(Cursor.HAND_CURSOR));
  }

  void hlkEasyXLS_mousePressed(MouseEvent e) {
    try {
      Runtime.getRuntime().exec("rundll32 url.dll,FileProtocolHandler " + hlkEasyXLS.getToolTipText());
    }
    catch (IOException ex) {
      JOptionPane.showMessageDialog(this,"The specified url cannot be accessed.","Error", JOptionPane.ERROR_MESSAGE);
    }
  }

  void btnExportToExcel_actionPerformed(ActionEvent e) {
     
    // Creating an instance of the object that generates excel files
    ExcelDocument xls = new ExcelDocument();

    // Adding a sheet to the Excel Document object
    ExcelWorksheet xlsWorksheet = new ExcelWorksheet("TimeSheetReport");
    xls.easy_addWorksheet(xlsWorksheet);

    // Adding the image
    xlsWorksheet.easy_addImage(imgEasyXLSlogo.getIcon().toString().replaceAll("\\\\", "\\\\\\\\"), "A1");

    // Adding the hyperlink
    xlsWorksheet.easy_addHyperlink(HyperlinkType.URL, hlkEasyXLS.getToolTipText(), "A5");

    //Create an instance of the object used to format the cells
    ExcelAutoFormat xlsAutoFormat = new ExcelAutoFormat(Styles.AUTOFORMAT_EASYXLS1);

    // Create the list used to store the values of the table
    EasyXLS.Util.List lstRows = new EasyXLS.Util.List();

    // Add the header row to the list
    EasyXLS.Util.List lstHeaderRow = new EasyXLS.Util.List();
    lstHeaderRow.addElement ("Project");
    lstHeaderRow.addElement ("Resource");
    lstHeaderRow.addElement ("Role");
    lstHeaderRow.addElement ("Task");
    lstHeaderRow.addElement ("Estimated");
    lstHeaderRow.addElement ("Regular");
    lstHeaderRow.addElement ("OT Hours");
    lstHeaderRow.addElement ("NB Hours");
    lstHeaderRow.addElement ("Approval Status");
    lstRows.addElement (lstHeaderRow);

    // Add the cells to the list
    for (int nRowIndex = 0; nRowIndex < dtTable.getRowCount(); nRowIndex++ )
    {
      EasyXLS.Util.List RowList = new EasyXLS.Util.List();
      for (int nColumnIndex = 0; nColumnIndex < dtTable.getColumnCount(); nColumnIndex++)
      {
        RowList.addElement (dtTable.getValueAt(nRowIndex, nColumnIndex));
      }
      lstRows.addElement (RowList);
    }

    // Adding the content of the grid
    xlsWorksheet.easy_insertList( lstRows, 6, 0, xlsAutoFormat);

    // Creating the footer
    int nFooterRowIndex = 6 + lstRows.size() - 1;
    ExcelTable xlsTable = xlsWorksheet.easy_getExcelTable();
    xlsTable.easy_getCell(nFooterRowIndex, 0).setValue ("Totals:");
    xlsTable.easy_getCell(nFooterRowIndex, 4).setValue ("=SUM(E8:E" + nFooterRowIndex + ")");
    xlsTable.easy_getCell(nFooterRowIndex, 4).setDataType(DataType.AUTOMATIC);
    xlsTable.easy_getCell(nFooterRowIndex, 5).setValue ("=SUM(F8:F" + nFooterRowIndex + ")");
    xlsTable.easy_getCell(nFooterRowIndex, 5).setDataType(DataType.AUTOMATIC);
    xlsTable.easy_getCell(nFooterRowIndex, 6).setValue ("=SUM(G8:G" + nFooterRowIndex + ")");
    xlsTable.easy_getCell(nFooterRowIndex, 6).setDataType(DataType.AUTOMATIC);
    xlsTable.easy_getCell(nFooterRowIndex, 7).setValue ("=SUM(H8:H" + nFooterRowIndex + ")");
    xlsTable.easy_getCell(nFooterRowIndex, 7).setDataType(DataType.AUTOMATIC);

    // Creating and adding a chart based on the grid's data
    ExcelChart xlsChart = new ExcelChart("A20", 600, 300);
    if (chkEstimated.isSelected())
      xlsChart.easy_addSeries("=TimeSheetReport!$E$7", "=TimeSheetReport!$E$8:$E$16");
    if (chkRegular.isSelected())
      xlsChart.easy_addSeries("=TimeSheetReport!$F$7", "=TimeSheetReport!$F$8:$F$16");
    if (chkOTHours.isSelected())
      xlsChart.easy_addSeries("=TimeSheetReport!$G$7", "=TimeSheetReport!$G$8:$G$16");
    if (chkNBHours.isSelected())
      xlsChart.easy_addSeries("=TimeSheetReport!$H$7", "=TimeSheetReport!$H$8:$H$16");

    if (chkEstimated.isSelected() || chkRegular.isSelected() || chkOTHours.isSelected() || chkNBHours.isSelected())
      xlsChart.easy_setCategoryXAxisLabels("=TimeSheetReport!$D$8:$D$16");
    else
      xlsChart.easy_addSeries("=TimeSheetReport!$D$7", "=TimeSheetReport!$D$8:$D$16");

    xlsWorksheet.easy_addChart(xlsChart);


    //Generate the file
    jLabel1.setText("Writing file C:\\Samples\\JDeveloperApplication.xls.");
    try {
      xls.easy_WriteXLSFile( "c:\\Samples\\JDeveloperApplication.xls");
    }
    catch (Exception ex) {
      jLabel1.setText("Error encountered: " + ex.toString());
    }

    // Confirm generation
    if (xls.easy_getError().equals(""))
      jLabel1.setText(jLabel1.getText() + "\r\n" + " File successfully created.");
    else
      jLabel1.setText("Error encountered: " + xls.easy_getError());


    //Dispose memory
    xls.Dispose();
  }
}